package it.telecomitalia.netbox;

import java.io.InputStreamReader;


import java.util.*;

import org.drools.*;
import org.drools.compiler.*;
import org.drools.audit.*;

public class MainProvaClass {

  private static final int TF_NUMBER=1000;
  
  /**
   * @param args
   */
  public static void main(String[] args){
    try{
      
      MainProvaClass prova=new MainProvaClass();
      prova.fireRuleEngineProva();
    }catch(Exception ex){
      ex.printStackTrace();
    }
  }
  
  public void fireRuleEngineProva() throws Exception{
    PackageBuilderConfiguration pbc=new PackageBuilderConfiguration();
    pbc.setJavaLanguageLevel("1.5");
    PackageBuilder builder = new PackageBuilder(pbc);
    builder.addPackageFromDrl( new InputStreamReader( MainProvaClass.class.getResourceAsStream( "ProvaAllarmi.drl" ) ) );
    RuleBase ruleBase = RuleBaseFactory.newRuleBase();
    ruleBase.addPackage( builder.getPackage() );
    WorkingMemory workingMemory = ruleBase.newWorkingMemory();
    //WorkingMemoryFileLogger logger = new WorkingMemoryFileLogger( workingMemory );
    //logger.setFileName( "C:\\temp\\provaAllarmi" );
    Node nodoA=new Node();
    nodoA.setDpc("09244");
    nodoA.setCountryId("IT");
    
    Node nodoB=new Node();
    nodoA.setDpc("09359");
    nodoA.setCountryId("DE");
    
    Tf aTf1=new Tf();
    aTf1.setNode(nodoA);
    aTf1.setNextNode(nodoB);
    aTf1.setTf("prova");
    
    Date start=new Date();
    Alarm[] allarmi=new Alarm[2*TF_NUMBER];
    for (int i =0; i<TF_NUMBER; i++){
      Tf aTf=new Tf();
      aTf.setNode(nodoA);
      aTf.setNextNode(nodoB);
      aTf.setTf("prova"+i);
      
      
      Misura terTf=new Misura();
      terTf.setName("TER");
      terTf.setReferencedTf(aTf);
      
      Misura schTf=new Misura();
      schTf.setName("SCH");
      schTf.setReferencedTf(aTf);
      
      
      Misura oflTf=new Misura();
      oflTf.setName("OFL");
      oflTf.setReferencedTf(aTf);
      
      allarmi[2*i]=new AllarmeMisura();
      allarmi[2*i].setReferencedElement(terTf);
      allarmi[2*i].setAdministrativeState("New");
      allarmi[2*i].setNetworkState("Open");
      workingMemory.assertObject(allarmi[2*i]);
      allarmi[2*i+1]=new AllarmeMisura();
      allarmi[2*i+1].setReferencedElement(schTf);
      allarmi[2*i+1].setAdministrativeState("New");
      allarmi[2*i+1].setNetworkState("Open");
      workingMemory.assertObject(allarmi[2*i+1]);
    }
    workingMemory.fireAllRules();
    System.out.println("Dopo aggiunta "+((new Date()).getTime() - start.getTime()));
    start=new Date();
    for (int i =0; i<TF_NUMBER; i++){
      FactHandle fh1=workingMemory.getFactHandle(allarmi[2*i]);
      FactHandle fh2=workingMemory.getFactHandle(allarmi[2*i+1]);
      allarmi[2*i+1].setNetworkState("Closed");
      allarmi[2*i].setNetworkState("Closed");
      
      workingMemory.modifyObject(fh1,allarmi[2*i]);
      workingMemory.modifyObject(fh2,allarmi[2*i+1]);
    }
    workingMemory.fireAllRules();
    System.out.println("Dopo rimozione "+((new Date()).getTime() - start.getTime()));
    //logger.writeToDisk();
  }

}
